﻿//EX31_bar_Code_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//



using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace EX31_Bar_Code_CS
{
    public partial class Form1 : Form
    {
        private PosExplorer myPosExplorer;
        private Scanner myScanner;


        public Form1()
        {
            InitializeComponent();
            myPosExplorer = new PosExplorer(this);
            myPosExplorer.DeviceAddedEvent += new DeviceChangedEventHandler(myPosExplorer_DeviceAddedEvent);
            myPosExplorer.DeviceRemovedEvent += new DeviceChangedEventHandler(myPosExplorer_DeviceRemovedEvent);

            DeviceInfo device = myPosExplorer.GetDevice("Scanner");
            //DeviceInfo device = myPosExplorer.GetDevice("Scanner", "myScanner");

            if (device == null)
            {
                lstItems.Items.Add("Scanner not found");
            }
            else
            {
                myScanner = (Scanner)myPosExplorer.CreateInstance(device);
                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;                
            }

        }

        void myScanner_DataEvent(object sender, DataEventArgs e)
        {
            ASCIIEncoding myEncoding = new ASCIIEncoding();
            lstItems.Items.Add(myEncoding.GetString(myScanner.ScanDataLabel));
            myScanner.DataEventEnabled = true;
        }

        void myPosExplorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Scanner")            
            {
                myScanner.DataEventEnabled = false;
                myScanner.DeviceEnabled = false;
                myScanner.Release();
                myScanner.Close();
                lstItems.Items.Add("Scanner removed");
            }
        }

        void myPosExplorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Scanner")
            {
                myScanner = (Scanner)myPosExplorer.CreateInstance(e.Device);
                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);   
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;
                lstItems.Items.Add("Scanner Attached");                             
            }
        }
    }
}
