﻿//EX32_MSSR_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace EX32_MSR_CS
{
    public partial class Form1 : Form
    {

        private PosExplorer myExplorer;
        private Msr myMsr;


        public Form1()
        {
            InitializeComponent();
            myExplorer = new PosExplorer(this);
            myExplorer.DeviceAddedEvent += new DeviceChangedEventHandler(myExplorer_DeviceAddedEvent);
            myExplorer.DeviceRemovedEvent += new DeviceChangedEventHandler(myExplorer_DeviceRemovedEvent);
            DeviceInfo device = myExplorer.GetDevice("Msr");

            if (device == null)
            {
                TTStatus.Text = "Msr Not Found";
            }
            else
            {
                myMsr = (Msr)myExplorer.CreateInstance(device);
                myMsr.Open();
                myMsr.Claim(1000);
                myMsr.DataEvent += new DataEventHandler(myMsr_DataEvent);
                myMsr.DeviceEnabled = true;
                myMsr.DataEventEnabled = true;
                myMsr.DecodeData = true;
                TTStatus.Text = "Found Msr - Ready";                
            }   
        }

        void myMsr_DataEvent(object sender, DataEventArgs e)
        {
            ASCIIEncoding myEncoding = new ASCIIEncoding();
            txtInput.Text = myEncoding.GetString(myMsr.Track2Data);
            myMsr.DataEventEnabled = true;
        }

        void myExplorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Msr")
            {
                myMsr.DataEventEnabled = false;
                myMsr.DeviceEnabled = false;
                myMsr.Release();
                myMsr.Close();
                TTStatus.Text = "Found Msr - removed";                
            }
        }

        void myExplorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Msr")
            {
                myMsr = (Msr)myExplorer.CreateInstance(e.Device);
                TTStatus.Text = "Found Msr - Ready";
                myMsr.Open();
                myMsr.Claim(1000);
                myMsr.DataEvent += new DataEventHandler(myMsr_DataEvent);
                myMsr.DeviceEnabled = true;
                myMsr.DataEventEnabled = true;
                myMsr.DecodeData = true;
            }
        }
    }
}
