﻿'AveryBerkel6710SO
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'

Imports Microsoft.PointOfService.BasicServiceObjects
Imports Microsoft.PointOfService
Imports System.Text
Imports System.IO.Ports
Imports System
Imports System.Threading


<ServiceObjectAttribute(DeviceType.Scale, "Avery Berkel 6710 Scale", "SJJ EMS AB 6710 Scale SO", 1, 12)> _
Public Class AveryBerkel6710SO
    Inherits ScaleBasic

    Protected sPort As SerialPort = New SerialPort("COM1", 9600, Parity.Even, 7, StopBits.One)

    Public Overrides Property AsyncMode As Boolean
        Get
            Return False
        End Get
        Set(ByVal value As Boolean)

        End Set
    End Property

    Public Overrides ReadOnly Property CapDisplay As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapDisplayText As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapPriceCalculating As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapTareWeight As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapZeroScale As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Function CheckHealth(ByVal level As Microsoft.PointOfService.HealthCheckLevel) As String
        Dim theStatus(6) As Char
        Dim FinalStatus As String = "ok"

        sPort.Write("S" & Chr(13))
        Thread.Sleep(1000)

        Try
            theStatus = sPort.ReadTo(Chr(3)).ToCharArray()
        Catch ex As Exception
            FinalStatus = StatusNotReady.ToString()

        End Try

        If (theStatus(1) & theStatus(2) & theStatus(3)) = "S10" Then
            FinalStatus = StatusWeightUnstable.ToString() 'scale is in motion

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S20" Then

            FinalStatus = StatusWeightZero.ToString() 'scale is at zero and stable

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S00" Then

            FinalStatus = StatusStableWeight.ToString() 'Scale Not at Zero and Stable

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S11" Then

            FinalStatus = ExtendedErrorOverWeight.ToString() 'Scale over Max Weight

        End If

        Return FinalStatus
    End Function

    Public Overrides ReadOnly Property CheckHealthText As String
        Get
            Return CheckHealth(HealthCheckLevel.Internal)
        End Get
    End Property

    Public Overrides Function DirectIO(ByVal command As Integer, ByVal data As Integer, ByVal obj As Object) As Microsoft.PointOfService.DirectIOData
        Return New DirectIOData(data, obj)
    End Function

    Public Overrides Sub DisplayText(ByVal data As String)

    End Sub

    Public Overrides ReadOnly Property MaxDisplayTextChars As Integer
        Get
            Return 0
        End Get
    End Property

    Public Overrides ReadOnly Property MaximumWeight As Decimal
        Get
            Return 30
        End Get
    End Property

    Public Overrides Function ReadWeight(ByVal timeout As Integer) As Decimal
        Dim theWeight(15) As Char
        Dim FinalWeight As Decimal

        sPort.Write("W" & Chr(13))
        Thread.Sleep(1000)

        Try
            theWeight = sPort.ReadTo(Chr(3)).ToCharArray()
        Catch ex As Exception

            Return -1 'failure to connect

        End Try

        If (theWeight(1) & theWeight(2) & theWeight(3)) = "S10" Then

            Return -1 'Scale in motion

        ElseIf (theWeight(1) & theWeight(2) & theWeight(3)) = "S11" Then

            Return -1 'Scale Over Max weight

        Else

            'If there are no errors than display weight
            FinalWeight = (theWeight(1) & theWeight(2) & theWeight(3) & theWeight(4) & theWeight(5) & theWeight(6))
            Return FinalWeight
        End If


    End Function

    Public Overrides ReadOnly Property SalesPrice As Decimal
        Get
            Return 0
        End Get
    End Property

    Public Overrides Property TareWeight As Decimal
        Get
            Return 0
        End Get
        Set(ByVal value As Decimal)

        End Set
    End Property

    Public Overrides Property UnitPrice As Decimal
        Get
            Return 0
        End Get
        Set(ByVal value As Decimal)

        End Set
    End Property

    Public Overrides ReadOnly Property WeightUnit As Microsoft.PointOfService.WeightUnit
        Get
            Return Microsoft.PointOfService.WeightUnit.Pound
        End Get
    End Property

    Public Overrides Sub ZeroScale()

        sPort.Write("Z" & Chr(13))
        Thread.Sleep(1000)


    End Sub

    Public Overrides Sub Open()
        MyBase.Open()
        sPort.PortName = DevicePath
        sPort.Open()

    End Sub

    Public Overrides Sub Close()

        sPort.Close()
        MyBase.Close()

    End Sub
End Class
