﻿//AveryBerkel6710SO_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using Microsoft.PointOfService;
using Microsoft.PointOfService.BasicServiceObjects;
using System.Threading;


namespace AveryBerkel6710SO_CS
{
    [ServiceObject(DeviceType.Scale, "Avery Berkel 6710 Scale", "SJJ EMS AB 6710 Scale SO", 1, 12)]
    public class AveryBerkel6710SO : Scale
    {

        protected SerialPort sPort = new SerialPort("COM1", 9600, Parity.Even, 7, StopBits.One);
        
        public override bool AsyncMode
        {
            get
            {
                return false;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override bool AutoDisable
        {
            get
            {
                return false;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override bool CapDisplay
        {
            get { return false; }
        }

        public override bool CapDisplayText
        {
            get { return false; }
        }

        public override bool CapPriceCalculating
        {
            get { return false; }
        }

        public override bool CapTareWeight
        {
            get { return false; }
        }

        public override bool CapZeroScale
        {
            get { return true; }
        }

        public override int MaxDisplayTextChars
        {
            get { return 0;  }
        }

        public override decimal MaximumWeight
        {
            get { return 30; }
        }

        public override decimal ReadWeight(int timeout)
        {

            Char[] theWeight = new char[16];
            Decimal FinalWeight = 0;
            sPort.Write("W" + (char)13);
            Thread.Sleep(1000);

            try
            {
                theWeight = sPort.ReadTo(((char)3).ToString()).ToArray(); //Read to the end of the line ETX
            }
            catch
            {
                return -1;
            }

            if ((theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString()) == "S10")
            {
                return -1;
            }
            else if ((theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString()) == "S11")
            {
                return -1;
            }
            else
            {
                FinalWeight = Decimal.Parse(theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString() + theWeight[4].ToString() + theWeight[5].ToString() + theWeight[6].ToString());
                return FinalWeight;
            }

        }

        public override decimal SalesPrice
        {
            get { return 0; }
        }

        public override decimal TareWeight
        {
            get
            {
                return 0;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override decimal UnitPrice
        {
            get
            {
                return 0;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override WeightUnit WeightUnit
        {
            get { return WeightUnit.Pound; }
        }

        public override void ZeroScale()
        {
            sPort.Write("Z" + (char)13);
            Thread.Sleep(1000);
        }


        public override string CheckHealth(HealthCheckLevel level)
        {
            Char[] theStatus = new char[7];
            String FinalStatus = "ok";

            sPort.Write("S" + (char)13);
            Thread.Sleep(1000);

            try
            {
                theStatus = sPort.ReadTo(((char)3).ToString()).ToArray();
            }
            catch
            {
                FinalStatus = StatusNotReady.ToString();                
            }

            if ((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S10")
            {
                FinalStatus = StatusWeightUnstable.ToString(); //scale is in motion
            }
            else if ((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S20")
            {
                FinalStatus = StatusWeightZero.ToString();  //scale is at zero and stable
            }
            else if ((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S00")
            {
                FinalStatus = StatusStableWeight.ToString(); //Scale Not at Zero and Stable
            }
            else if ((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S00")
            {
                FinalStatus = ExtendedErrorOverWeight.ToString(); //Scale over Max Weight
            }

            return FinalStatus;            

        }

        public override string CheckHealthText
        {
            get 
            {
                return CheckHealth(HealthCheckLevel.Internal);
            
            }
        }


        public override void ClearInput()
        {
            throw new NotImplementedException();
        }

        public override int DataCount
        {
            get { return 0; }
        }

        public override event DataEventHandler DataEvent;

        public override bool DataEventEnabled
        {
            get
            {
                return false;
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override void DisplayText(string data)
        {
            throw new NotImplementedException();
        }

        public override event DeviceErrorEventHandler ErrorEvent;

        public override PowerReporting CapPowerReporting
        {
            get { throw new NotImplementedException(); }
        }

        public override bool CapStatisticsReporting
        {
            get { return false; }
        }

        public override bool CapUpdateStatistics
        {
            get { return false; }
        }

        public override void Claim(int timeout)
        {
            //Visual studio will not build if the method is missing.
            int x = 0;
            timeout = x + 100;
        }

        public override bool Claimed
        {
            get { return true; }
        }

        public override void Close()
        {
            sPort.Close();
        }

        public override string DeviceDescription
        {
            get { throw new NotImplementedException(); }
        }

        public override bool DeviceEnabled
        {
            get
            {
                return true;
            }
            set
            {
                bool ScaleEnabled;
                ScaleEnabled = DeviceEnabled; 
            }
        }

        public override string DeviceName
        {
            get { return "Avery Berkel 6710"; }
        }

        public override DirectIOData DirectIO(int command, int data, object obj)
        {
            throw new NotImplementedException();
        }

        public override event DirectIOEventHandler DirectIOEvent;

        public override bool FreezeEvents
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }


        public override PowerNotification PowerNotify
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public override PowerState PowerState
        {
            get { throw new NotImplementedException(); }
        }

        public override void Release()
        {
            //Visual studio will not build if the method is missing.
            int x = 0;
            x++;
        }

        public override void ResetStatistic(string statistic)
        {
            throw new NotImplementedException();
        }

        public override void ResetStatistics(string[] statistics)
        {
            throw new NotImplementedException();
        }

        public override void ResetStatistics(StatisticCategories statistics)
        {
            throw new NotImplementedException();
        }

        public override void ResetStatistics()
        {
            throw new NotImplementedException();
        }

        public override string RetrieveStatistic(string statistic)
        {
            throw new NotImplementedException();
        }

        public override string RetrieveStatistics(string[] statistics)
        {
            throw new NotImplementedException();
        }

        public override string RetrieveStatistics(StatisticCategories statistics)
        {
            throw new NotImplementedException();
        }

        public override string RetrieveStatistics()
        {
            throw new NotImplementedException();
        }

        public override string ServiceObjectDescription
        {
            get { return "Scale"; }
        }

        public override ControlState State
        {
            get { throw new NotImplementedException(); }
        }

        public override event StatusUpdateEventHandler StatusUpdateEvent;

        public override void UpdateStatistic(string name, object value)
        {
            throw new NotImplementedException();
        }

        public override void UpdateStatistics(StatisticCategories statistics, object value)
        {
            throw new NotImplementedException();
        }

        public override void UpdateStatistics(Statistic[] statistics)
        {
            throw new NotImplementedException();
        }

        public override void Open()
        {
            sPort.PortName = DevicePath;
            sPort.Open();
        }
    }
}
