﻿'ScaleSOTest
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'

Imports Microsoft.PointOfService
Imports System.Text

Public Class Form1
    WithEvents myPosExplorer As PosExplorer
    Dim myScale As Scale

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        myPosExplorer = New PosExplorer(Me)

        Dim device1 As DeviceInfo = myPosExplorer.GetDevice("Scale")
        If device1 Is Nothing Then
            ttStatus.Text = "Scale Not Found"
        Else
            myScale = myPosExplorer.CreateInstance(device1)

            myScale.Open()
            myScale.Claim(1000)
            myScale.DeviceEnabled = True
            ttStatus.Text = "Scale Ready"
        End If

    End Sub

    Private Sub btnGW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGW.Click
        Dim theWeight As Decimal
        Dim ScaleStatus As String

        Try
            theWeight = myScale.ReadWeight(1000)
        Catch ex As Exception
            theWeight = "0.00"
        End Try
        If theWeight = "-1" Then

            ScaleStatus = myScale.CheckHealth(HealthCheckLevel.Internal)

            Select Case (ScaleStatus)

                Case "11"
                    ttStatus.Text = "Scale Stable and not at Zero"

                Case "12"
                    ttStatus.Text = "Scale is in motion and not ready"

                Case "13"
                    ttStatus.Text = "Scale is at Zero and Stable"

                Case Else
                    ttStatus.Text = "Unkown Error"

            End Select


        Else
            lblResult.Text = theWeight & " lbs"
            ttStatus.Text = "Ready"
        End If
    End Sub

    Private Sub btnZS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZS.Click
        myScale.ZeroScale()
        ttStatus.Text = "Zero Command called, check scale display"
    End Sub

    Private Sub btnStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStatus.Click

        Dim ScaleStatus As String = myScale.CheckHealth(HealthCheckLevel.Internal)

        Select Case (ScaleStatus)

            Case "11"
                ttStatus.Text = "Scale Stable and not at Zero"

            Case "12"
                ttStatus.Text = "Scale is in motion and not ready"

            Case "13"
                ttStatus.Text = "Scale is at Zero and Stable"

            Case Else
                ttStatus.Text = "Unkown Error"

        End Select


    End Sub

    Protected Overrides Sub Finalize()

        myScale.Close()

        MyBase.Finalize()
    End Sub
End Class
