﻿//ScaleSOTest
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace ScaleSOTest_CS
{
    public partial class Form1 : Form
    {

        PosExplorer myExplorer;
        Scale myScale;
        
        public Form1()
        {
            InitializeComponent();

            myExplorer = new PosExplorer(this);

            DeviceInfo device1 = myExplorer.GetDevice("Scale");
            if (device1 == null)
            {
                ttStatus.Text = "Scale Not Found";
            }
            else
            {
                myScale = (Scale)myExplorer.CreateInstance(device1);
                myScale.Open();
                myScale.Claim(1000);
                myScale.DeviceEnabled = true;
                ttStatus.Text = "Scale Ready";
            }

        }

        private void btnGW_Click(object sender, EventArgs e)
        {
            Decimal theWeight = 0;
            String ScaleStatus;

            try
            {
                theWeight = myScale.ReadWeight(1000);
            }
            catch
            {
                theWeight = 0;
                ttStatus.Text = "Error";
            }
                                    
            if (theWeight.ToString() == "-1")
            {

                ScaleStatus = myScale.CheckHealth(HealthCheckLevel.Internal);
                switch (ScaleStatus)
                {
                    case "11":
                        ttStatus.Text = "Scale Stable and not at Zero";
                        break;

                    case "12":
                        ttStatus.Text = "Scale is in motion and not ready";
                        break;

                    case "13":
                        ttStatus.Text = "Scale is at Zero and Stable";
                        break;

                    default:
                        ttStatus.Text = "Unkown Error";
                        break;
                }
            }
            else
            {
                lblResult.Text = theWeight.ToString() + " lbs";
                ttStatus.Text = "Ready";
            }

        }

        private void btnZS_Click(object sender, EventArgs e)
        {
            myScale.ZeroScale();
            ttStatus.Text = "Zero Command called, check scale display";
        }

        private void btnStatus_Click(object sender, EventArgs e)
        {
            
            String ScaleStatus = myScale.CheckHealth(HealthCheckLevel.Internal);
            switch (ScaleStatus)
            {
                case "11":
                    ttStatus.Text = "Scale Stable and not at Zero";
                    break;

                case "12":
                    ttStatus.Text = "Scale is in motion and not ready";
                    break;

                case "13":
                    ttStatus.Text = "Scale is at Zero and Stable";
                    break;

                default:
                    ttStatus.Text = "Unkown Error";
                    break;
            }
            
        }
    }
}
