﻿//ScaleTest_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO.Ports;

namespace ScaleTest_CS
{
    public partial class Form1 : Form
    {

        private SerialPort sPort = new SerialPort("COM1", 9600, Parity.Even, 7, StopBits.One);
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGetWeight_Click(object sender, EventArgs e)
        {
            Char[] theWeight = new char[16];
            sPort.Open();
            sPort.Write("W" + (char)13);
            Thread.Sleep(1000);

            try{

                theWeight = sPort.ReadTo(((char)3).ToString()).ToArray(); //Read to the end of the line ETX
            }
            catch(Exception ex)
            {
                ttStatus.Text =    "Error Reading Weight"; 

            }
            if((theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString()) == "S10")
            {
                ttStatus.Text = "Scale in motion";
            }
            else if ((theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString()) == "S11")
            {
                ttStatus.Text = "Scale Over Capacity";
            }
            else
            {
                lstItems.Items.Add(theWeight[1].ToString() + theWeight[2].ToString() + theWeight[3].ToString() + theWeight[4].ToString() + theWeight[5].ToString() + theWeight[6].ToString() + theWeight[7].ToString() + theWeight[8].ToString());
            }

            sPort.Close();
        }

        private void btnZero_Click(object sender, EventArgs e)
        {
        
            Char[] theZeroStatus = new char[6];
            sPort.Open();
            sPort.Write("Z" + (char)13);
            Thread.Sleep(1000);

            try
            {
                theZeroStatus = sPort.ReadTo(((char)3).ToString()).ToArray();
            }
            catch(Exception ex)
            {
                ttStatus.Text = "Error with Zeroing scale";
            }

            if((theZeroStatus[1].ToString() + theZeroStatus[2].ToString() + theZeroStatus[3].ToString()) == "S10")
            {
                ttStatus.Text = "Scale in motion";
            }
            else if((theZeroStatus[1].ToString() + theZeroStatus[2].ToString() + theZeroStatus[3].ToString()) == "S20")
            {
                ttStatus.Text = "Scale at Zero";
            }

            sPort.Close();
        }

        private void btnStatus_Click(object sender, EventArgs e)
        {
        
            Char[] theStatus = new char[6];
            sPort.Open();
            sPort.Write("S" + (char)13);
            Thread.Sleep(1000);

           try
           {
               theStatus = sPort.ReadTo(((char)3).ToString()).ToArray();
           }
           catch(Exception ex)
           {
                ttStatus.Text = "Error Reading State";
           }
            
            if((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S10")
            {
                ttStatus.Text = "Scale in motion";
            }
            else if((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S20")
            {
                ttStatus.Text = "Scale at Zero and Stable";
            }
            else if((theStatus[1].ToString() + theStatus[2].ToString() + theStatus[3].ToString()) == "S00")
            {
                ttStatus.Text = "Scale Not at Zero and Stable";
            }

            sPort.Close();
        }
    }
}
