﻿'WASPCashDrawerSO
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'

Imports Microsoft.PointOfService.BaseServiceObjects
Imports Microsoft.PointOfService
Imports System.Text
Imports System.IO.Ports
Imports System

<ServiceObjectAttribute(DeviceType.CashDrawer, "WASP Cash Drawer", "SJJ EMS WASP Cash Drawer SO", 1, 12)> _
Public Class WASPCashDrawerSO
    Inherits CashDrawerBase
    Private sPort As SerialPort = New SerialPort("COM1", 38400, Parity.None, 8) 'This sets the defaults COM port settings

    Public Overrides Function CheckHealth(ByVal level As Microsoft.PointOfService.HealthCheckLevel) As String
        'Verify that device is open, claimed and enabled
        VerifyState(True, True)
        Return CheckHealthText
    End Function

    Public Overrides ReadOnly Property CheckHealthText As String
        Get
            'Verify that device is open
            VerifyState(False, False)
            CheckHealthText = "ok"
            Return CheckHealthText
        End Get
    End Property

    Public Overrides Function DirectIO(ByVal command As Integer, ByVal data As Integer, ByVal obj As Object) As Microsoft.PointOfService.DirectIOData
        Return New DirectIOData(data, obj)
    End Function

    Protected Overrides Sub OpenDrawerImpl()
        sPort.PortName = DevicePath
        sPort.Open()
        sPort.Write(Chr(27) & Chr(112) & Chr(0) & Chr(25) & Chr(30))
        sPort.Close()
    End Sub
End Class
