﻿//WASPCashDrawerSO_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using Microsoft.PointOfService;
using Microsoft.PointOfService.BaseServiceObjects;

namespace WASPCashDrawerSO_CS
{
    [ServiceObject(DeviceType.CashDrawer, "WASP Cash Drawer","SJJ EMS WASP Cash Drawer SO",1,12)]
    public class WASPCashDrawerSO : CashDrawerBase
    {
        SerialPort sPort = new SerialPort("COM1", 38400, Parity.None, 8);

        protected override void OpenDrawerImpl()
        {
            sPort.PortName = DevicePath;
            sPort.Open();
            sPort.Write("" + ((char)27) + ((char)112) + ((char)0) + ((char)25) + ((char)30));
            sPort.Close();
        }

        public override string CheckHealth(HealthCheckLevel level)
        {
            VerifyState(true, true);
            return CheckHealthText;
        }

        public override string CheckHealthText
        {
            get {
                VerifyState(false, false);
                return "ok";    
            }
        }

        public override DirectIOData DirectIO(int command, int data, object obj)
        {
            return new DirectIOData(data, obj);
        }
    }
}
