﻿'CashRegister
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'

Imports Microsoft.PointOfService
Imports System.Text
Imports System.Data
Imports System.Data.OleDb

Public Class CashRegister
    'There are 5 POS devices for use with this application 
    WithEvents explorer As PosExplorer
    WithEvents myScanner As Scanner
    WithEvents myMSR As Msr
    Dim myDisplay As LineDisplay
    Dim myPrinter As PosPrinter
    Dim myCashDrawer As CashDrawer

    'There are the global variables. SaleTotal is used to calculate the on going
    'Sale total as items are added and removed. CashPayment and CreditCardPayment
    'are used as flags to set the state of the keypad and printout and cash drawer
    'options.

    Dim SaleTotal As Decimal = 0
    Dim CashPayment As Boolean = False
    Dim CreditCardPayment As Boolean = False



    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        explorer = New PosExplorer(Me)

        'Call Subroutine to initialize the POS devices
        'The call to initialize the POS devices are in a subroutine
        InitializeDevices()

        lblChange.Visible = False
        lblCCName.Visible = False
        txtCCName.Visible = False
        txtChange.Visible = False



    End Sub

#Region "Key Pad Buttons"

    '******************************************************************************************************************
    '
    'btnEnter_Click(
    'The Enter button performs different actions depending upon the state of the system:
    '
    'Scan Items - Numbers entered for a bar code are then checked against the database
    'CashPayment - calculate change, print receipt and opening the cash draw
    'CreditCard Payment - print receipt
    '
    '


    Private Sub btnEnter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnter.Click


        '
        'Enter Items in the items list if we are in the scan state. Basically we check against the database for the item.
        '
        'Connect to the Database
        Dim dbConnect As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Database\Inventory.mdb")
        'Dim rowIndex As Integer = 0

        dbConnect.Open()

        Dim dbAdapter As New OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect)
        Dim dbDataSet As New DataSet

        dbAdapter.Fill(dbDataSet, "Inventory")

        Dim dbTable As DataTable = dbDataSet.Tables("Inventory")


        If CashPayment.Equals(False) And CreditCardPayment.Equals(False) Then
            'Perform an udpate for any information entered into the text boxes
            Update()
            myDisplay.ClearText()

            Dim myItem As String = txtItemInput.Text

            For Each row As DataRow In dbTable.Rows

                Dim ItemNo As String = row("ItemNo").ToString()
                Dim ItemName As String = row("ItemName").ToString()
                Dim BarCode As String = row("BarCode").ToString()
                Dim QTY As Integer = row("QTY").ToString()
                Dim Price As String = row("Price").ToString()

                If BarCode = myItem Then
                    Dim myItem2 As String = ItemName & " $" & Price
                    lstITEMS.Items.Add(myItem2)
                    myDisplay.DisplayText(ItemName & " $" & Price)
                    SaleTotal = SaleTotal + Price
                    txtItemInput.Clear()
                    lblStatus.Text = "Item added"
                    Update()
                    Exit For
                End If
            Next
            txtTotal.Text = SaleTotal
            Update()
        End If

        '
        'Process a cash payment
        '
        If CashPayment.Equals(True) Then
            If txtItemInput.Text = "" Then
                lblStatus.Text = "Need to enter value"
                Update()
            Else
                btnCancelSale.Enabled = False
                SalesReceipt()
            End If
        End If

        '
        'Process a credit card payment
        '
        If CreditCardPayment.Equals(True) Then
            If txtItemInput.Text = "" Then
                lblStatus.Text = "Need to enter value"
                Update()
            Else
                btnCancelSale.Enabled = False
                SalesReceipt()
            End If
        End If

        dbTable.Clear()
        dbDataSet.Clear()
        dbConnect.Close()

    End Sub

    '******************************************************************************************************************
    '
    'txtItemInput_KeyPress
    'When someone types in a bar code, cash payment, or credit card number and then hits enter
    'this Subroutine performs the Enter button click and jumps to the btnEnter_Click routine
    '


    Private Sub txtItemInput_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtItemInput.KeyPress
        'Adds item to sale with an Enter press either by Scanner or keyboard
        If e.KeyChar = Chr(13) Then
            Me.btnEnter.PerformClick()
        End If

    End Sub

    '******************************************************************************************************************
    '
    'Key Pad Buttons
    'Use to enter numbers into the txtItemInput box - Barcodes, cash paymet, credit card numbers
    '
    Private Sub btnNum1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum1.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "1"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum2.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "2"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum3.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "3"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum4.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "4"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum5.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "5"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum6.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "6"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum7.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "7"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum8.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "8"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum9.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "9"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum0.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "0"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNumDot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNumDot.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "."
        txtItemInput.Text = tempValue
        Update()
    End Sub
    '******************************************************************************************************************
    '
    'btnClear_Click
    'Clears the txtItemInput text box - quick clear solution
    '
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        'Clear the Input
        txtItemInput.Clear()
    End Sub
    '******************************************************************************************************************
    '
    'btnBack_Click
    'Provides back space functionality
    '
    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click
        Dim tempItem As String
        Dim tempItemIndex As Integer
        Update()
        tempItem = txtItemInput.Text
        tempItemIndex = tempItem.Length

        If tempItemIndex > 0 Then
            txtItemInput.Text = tempItem.Substring(0, tempItemIndex - 1)
            Update()
        End If
    End Sub

#End Region

#Region "Functional buttons"
    '******************************************************************************************************************
    '
    'btnCancelSale_Click
    'Clears out the current sale and state
    '
    Private Sub btnCancelSale_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancelSale.Click
        lstITEMS.Items.Clear()
        myDisplay.ClearText()
        myDisplay.DisplayText("Sale cancelled")
        txtTotal.Text = 0.0
        SaleTotal = 0
        cmdRemove.Enabled = True
        lblStatus.Text = "Sale cancelled"
        lblState.Text = "Enter Item Number"
        lblChange.Visible = False
        lblCCName.Visible = False
        txtCCName.Visible = False
        txtChange.Visible = False
        txtItemInput.Text = ""
        txtCCName.Text = ""
        txtChange.Text = ""
        CashPayment = False
        CreditCardPayment = False
        Update()
    End Sub

    '******************************************************************************************************************
    '
    'btnNewSale_Click
    'Press this button after a sale has been competed
    '
    Private Sub btnNewSale_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewSale.Click
        lstITEMS.Items.Clear()
        myDisplay.ClearText()
        myDisplay.DisplayText("Welcome")
        txtTotal.Text = 0.0
        txtItemInput.Clear()
        SaleTotal = 0
        cmdRemove.Enabled = True
        btnCancelSale.Enabled = True
        lblStatus.Text = "Ready"
        lblState.Text = "Enter Item Number"
        lblChange.Visible = False
        lblCCName.Visible = False
        txtCCName.Visible = False
        txtChange.Visible = False
        txtItemInput.Text = ""
        txtCCName.Text = ""
        txtChange.Text = ""
        CashPayment = False
        CreditCardPayment = False
        Update()
    End Sub
    '******************************************************************************************************************
    '
    'cmdRemove_Click
    'Removes an item from the list. Because teh lsit is only containing text, the database is required to 
    'create a comparison so when the item is removed, the SaleTotal can be updated.
    '
    Private Sub cmdRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRemove.Click
        'Create a connection to the database, also need an integer to get the item location
        'in the list box
        Update()
        myDisplay.ClearText()
        Dim ListItemIndex As Integer = lstITEMS.SelectedIndex()

        Dim dbConnect As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Database\Inventory.mdb")
        Dim rowIndex As Integer = 0

        dbConnect.Open()

        Dim dbAdapter As New OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect)
        Dim dbDataSet As New DataSet

        dbAdapter.Fill(dbDataSet, "Inventory")

        Dim dbTable As DataTable = dbDataSet.Tables("Inventory")


        If ListItemIndex >= 0 Then
            For Each row As DataRow In dbTable.Rows
                Dim ItemNo As String = row("ItemNo").ToString()
                Dim ItemName As String = row("ItemName").ToString()
                Dim BarCode As String = row("BarCode").ToString()
                Dim QTY As Integer = row("QTY").ToString()
                Dim Price As String = row("Price").ToString()
                'The item list is a combination of the ItemName and price 
                'So we need a string to copare too.
                Dim myItem As String = ItemName & " $" & Price

                'Once the item is found it is removed from the list and the SaleTotl
                'is updated
                If lstITEMS.SelectedItem = myItem Then
                    myDisplay.DisplayText(ItemName & " Removed")
                    SaleTotal = SaleTotal - Price
                    lstITEMS.Items.RemoveAt(ListItemIndex)
                    Exit For
                End If
            Next
        End If

        'Update the total Sale
        txtTotal.Text = SaleTotal
        lblStatus.Text = "Item removed"
        Update()

        dbTable.Clear()
        dbDataSet.Clear()
        dbConnect.Close()
    End Sub

    '******************************************************************************************************************
    '
    'btnCash_Click
    'When the Cash button is pressed, this is the start of the sales process. The keypad entery changes so the 
    'txtItemInput is an entery for cash receive, a change box appears so the clerk can see the change do
    'The global setting for CashPayment is set to true, which will direct the Enter button to take the 
    'appropriate acction.
    '
    Private Sub btnCash_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCash.Click
        CashPayment = True
        cmdRemove.Enabled = False
        lblState.Text = "Enter cash received:"
        lblChange.Visible = True
        txtChange.Visible = True
        Update()
    End Sub
    '******************************************************************************************************************
    '
    'btnCheck_Click
    'Does nothing. If there was a check reader attached this code could be filled in
    '
    Private Sub btnCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck.Click
        lblStatus.Text = "Sorry No Checks"
        myDisplay.ClearText()
        myDisplay.DisplayText("Sorry No Checks Accepted")
        Update()
    End Sub
    '******************************************************************************************************************
    '
    'btnCreditCard_Click
    'When the Credit Card button is pressed, this is the start of the sales process. The keypad entery changes so the 
    'txtItemInput is an entery for credit card entry, A Name box appears so when the card is swiped 
    'the database result will show the correct card carriers name to check against the card.
    'The global setting for CreditCardPayment is set to true, which will direct the Enter button to take the 
    'appropriate acction. This routine will also open the MSR.
    '
    Private Sub btnCreditCard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreditCard.Click
        lblState.Text = "Slide Credit Card"
        Update()
        CashPayment = False
        CreditCardPayment = True
        lblCCName.Visible = True
        txtCCName.Visible = True
        cmdRemove.Enabled = False

        myMSR.Open()
        myMSR.Claim(1000)
        myMSR.DeviceEnabled = True
        myMSR.DataEventEnabled = True
        myMSR.DecodeData = True
    End Sub



#End Region

#Region "POS Devices"

    '******************************************************************************************************************
    '
    'InitializeDevices
    'Here we initialize the different POS devices. Assuming that the logical names have been setup correctly,
    'a create isntance of the five device will be performed. If there is a device missing or not functional, the Status box
    'will list the missing devices. 
    'The line display and the SCanner are the only two devices that need to be opended and enabled. The others
    'will be opened, claimed, and enabled as there are needed.

    Private Sub InitializeDevices()

        Dim DeviceStr As String = ""
        Dim eFlag As Boolean = False

        'Poll Display setup
        'If the display is not attached it cannot be claimed. An exception will pop
        'if we don't have the try-catch in place. The Try Catch will be used for all
        '5 POS devices
        Try
            Dim device As DeviceInfo = explorer.GetDevice("LineDisplay")
            myDisplay = explorer.CreateInstance(device)
            myDisplay.Open()
            myDisplay.Claim(1000)
            myDisplay.DeviceEnabled = True
            myDisplay.ClearText()
            myDisplay.DisplayText("SJJ EMS              POS for .NET")
        Catch ex As Exception
            DeviceStr = DeviceStr & " LineDisplay"
            eFlag = True

        End Try


        'Now lets get the Printer
        Try
            Dim device2 As DeviceInfo = explorer.GetDevice("PosPrinter")
            myPrinter = explorer.CreateInstance(device2)
            myPrinter.Open()
            myPrinter.Claim(1000)
            myPrinter.AsyncMode = False
            myPrinter.DeviceEnabled = True
        Catch ex As Exception
            DeviceStr = DeviceStr & " Printer"
            eFlag = True
        End Try

        'Get the Cash Drawer
        Try
            Dim device3 As DeviceInfo = explorer.GetDevice("CashDrawer")
            myCashDrawer = explorer.CreateInstance(device3)
        Catch ex As Exception
            DeviceStr = DeviceStr & " Cash Drawer"
            eFlag = True

        End Try

        'Connect the MSR
        Try
            Dim device4 As DeviceInfo = explorer.GetDevice("Msr", "myMSR")
            myMSR = explorer.CreateInstance(device4)
        Catch ex As Exception
            DeviceStr = DeviceStr & " MSR"
            eFlag = True

        End Try

        'Finally, connect the Bar Code Scanner
        Try
            Dim device5 As DeviceInfo = explorer.GetDevice("Scanner", "myScanner")
            myScanner = explorer.CreateInstance(device5)
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True

        Catch ex As Exception
            DeviceStr = DeviceStr & " Scanner"
            eFlag = True

        End Try

        'If anything is missing then list it in the status box.
        If eFlag.Equals(True) Then
            lblStatus.Text = "No" & DeviceStr & " Attached - Reconnect or Replace"
        Else
            lblStatus.Text = "Ready"
        End If
        Update()

    End Sub

    '******************************************************************************************************************
    '
    'explorer_DeviceAddedEvent
    'explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
    'Here we will check to see what devices were added and display to the line display and status box
    '
    '
    Private Sub explorer_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles explorer.DeviceAddedEvent
        'Since the scanner is used from the onset, we imediately open the scanner.
        If (e.Device.Type = "Scanner") Then
            myScanner = explorer.CreateInstance(e.Device)
            myDisplay.ClearText()
            myDisplay.DisplayText("New bar-code scanner attached")
            lblStatus.Text = "New bar-code scanner attached: " & e.Device.ServiceObjectName
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
            Update()
        End If

        'We only use the MSR when there is a credit card payment
        'We only need to create and instance of the device. The MSR will be opened later

        If (e.Device.Type = "Msr") Then
            myMSR = explorer.CreateInstance(e.Device)
            myDisplay.ClearText()
            myDisplay.DisplayText("New MSR attached")
            lblStatus.Text = "New Msr attached: " & e.Device.ServiceObjectName
            Update()
        End If
    End Sub

    '******************************************************************************************************************
    '
    'explorer_DeviceRemoveEvent
    'explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
    'Here we will check to see what devices were removed added and display to the line display and status box
    '
    '
    Private Sub explorer_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles explorer.DeviceRemovedEvent
        'Close out the scanner
        If (e.Device.Type = "Scanner") Then
            myDisplay.ClearText()
            myDisplay.DisplayText("Bar-code scanner removed")
            lblStatus.Text = "Bar-code scanner removed"
            myScanner.DecodeData = False
            myScanner.DataEventEnabled = False
            myScanner.DeviceEnabled = False
            myScanner.Release()
            myScanner.Close()
            Update()
        End If
        'Close out the MSR
        If (e.Device.Type = "Msr") Then
            myDisplay.ClearText()
            myDisplay.DisplayText("Msr removed")
            lblStatus.Text = "Msr removed"
            myMSR.DataEventEnabled = False
            myMSR.DecodeData = False
            myMSR.Release()
            myMSR.Close()
            lblStatus.Text = "Msr Detached"
            Update()
        End If
    End Sub

    '******************************************************************************************************************
    '
    'MyScanner_DataEvent
    'As we scan items, the barcode that was just scanned will then be checked against the database. If an item
    'is found it will then be listed in the list box and the SaleTotal will e udpated. This code could be combined with the 
    'Enter button to compact the code listing - this will be left up to the reader.
    '

    Private Sub myScanner_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myScanner.DataEvent

        Dim myEncoding As New ASCIIEncoding
        Dim myScan As String = myEncoding.GetString(myScanner.ScanDataLabel)
        Dim dbConnect As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Database\Inventory.mdb")
        'Dim rowIndex As Integer = 0

        dbConnect.Open()

        Dim dbAdapter As New OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect)
        Dim dbDataSet As New DataSet

        dbAdapter.Fill(dbDataSet, "Inventory")

        Dim dbTable As DataTable = dbDataSet.Tables("Inventory")

        myDisplay.ClearText()

        For Each row As DataRow In dbTable.Rows
            Dim ItemNo As String = row("ItemNo").ToString()
            Dim ItemName As String = row("ItemName").ToString()
            Dim BarCode As String = row("BarCode").ToString()
            Dim QTY As Integer = row("QTY").ToString()
            Dim Price As String = row("Price").ToString()

            If BarCode = myScan Then
                Dim myItem As String = ItemName & " $" & Price
                lstITEMS.Items.Add(myItem.ToString)
                myDisplay.DisplayText(ItemName & " $" & Price)
                SaleTotal = SaleTotal + Price
                txtItemInput.Clear()
                lblStatus.Text = "Item added"
                Update()
                Exit For
            End If
        Next

        txtTotal.Text = SaleTotal
        Update()
        dbTable.Clear()
        dbDataSet.Clear()
        dbConnect.Close()
        myScanner.DataEventEnabled = True

    End Sub

    '******************************************************************************************************************
    '
    'myScanner_ErrorEvent
    'If there is an error scanning the item, then indicate this on the Status Box, and re-enable the 
    'scanner data event - don't leave the scanner disabled or someone will think the scanner
    'went bad.
    '

    Private Sub myScanner_ErrorEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceErrorEventArgs) Handles myScanner.ErrorEvent
        lblStatus.Text = "Error with card"
        Update()
        myScanner.DataEventEnabled = True
    End Sub

    '******************************************************************************************************************
    '
    'OpenCashDrawer
    'Seperate subroutine to open the WASP 5000 cash drawer. One could add a button to open the cash drawer
    'independent of the sales process.
    '

    Sub OpenCashDrawer()

        myCashDrawer.Open()
        myCashDrawer.Claim(1000)
        myCashDrawer.DeviceEnabled = True
        myCashDrawer.OpenDrawer()
        myCashDrawer.DeviceEnabled = False
        myCashDrawer.Release()
        myCashDrawer.Close()

        lblStatus.Text = "Cash Drawer Open"
        Update()

    End Sub
    '******************************************************************************************************************
    '
    'myMSR_DataEvent
    'When the Credit Card button is pressed, the MSR is the opened, claimed, and enabled for reading a card
    'This routine checks the msrData Track 2 against a database of credit cards to see if the card is valid
    'If it is valid, the sale will be processed; if not it will be denied. Of course, the code would really call
    'back into the credit card company for verification. Accessing a local database is just for demonstration
    '
    Private Sub myMSR_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myMSR.DataEvent
        Dim myEncode As New ASCIIEncoding
        Dim msrData As String = myEncode.GetString(myMSR.Track2Data)

        Dim dbConnect As New OleDbConnection
        Dim dbCommand As New OleDbCommand
        Dim dbreader As OleDbDataReader

        dbConnect = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Database\POS_ID.mdb")
        dbConnect.Open()
        dbCommand = New OleDbCommand("SELECT EmployeeID, Name, BadgeNumber, Access FROM Employees", dbConnect)
        dbreader = dbCommand.ExecuteReader

        While dbreader.Read
            Dim strID As String = CStr(dbreader("EmployeeID"))
            Dim Name As String = dbreader("Name")
            Dim Badge As String = dbreader("BadgeNumber")
            Dim Access As Boolean = dbreader("Access")

            'Display the user name of the card and then display there access
            If Badge = msrData Then
                txtItemInput.Text = msrData
                If Access.Equals(True) Then
                    txtCCName.Text = Name
                    lblStatus.Text = "Card OK"
                    myDisplay.ClearText()
                    myDisplay.DisplayText("Card OK")
                    btnCancelSale.Enabled = False
                    Update()
                    SalesReceipt()
                    myMSR.DataEventEnabled = False
                    myMSR.DecodeData = False
                    myMSR.Release()
                    myMSR.Close()
                    Exit While
                Else
                    lblStatus.Text = "Invalid Card - Try again"
                    Update()
                    Exit While
                End If
            End If

        End While

        dbreader.Close()
        dbreader = Nothing
        dbConnect.Close()
        dbConnect = Nothing
        myMSR.DataEventEnabled = True


    End Sub

    '******************************************************************************************************************
    '
    'myMSR_ErrorEvent
    'Like the scanner, the myMSR_ErrorEvent indicates to the user that an error occured and re-enables the device
    '

    Private Sub myMSR_ErrorEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceErrorEventArgs) Handles myMSR.ErrorEvent
        lblStatus.Text = "Error with card"
        Update()
        myMSR.DataEventEnabled = True
    End Sub

    '******************************************************************************************************************
    '
    'SalesReceipt
    'Processes the sale. If cash payment calculate the change; if credit card list the number in the text box - 
    'Open the printer and print out the appropriate information based on CAshPayment and CreditCardPayent flags
    'Close the printer when finished.
    '
    Sub SalesReceipt()
        Dim ItemCount As Integer
        Dim X As Integer
        Dim myString As String
        Dim myString2 As String
        Dim TodaysDate As String = Date.Now.ToString()

        Dim Payment As String = ""
        Dim PaymentValue As Decimal = 0

        If CashPayment.Equals(True) Then
            PaymentValue = txtItemInput.Text.ToString()
            If SaleTotal > PaymentValue Then
                lblStatus.Text = "Wrong Cash Amount"
                Update()
                Exit Sub
            End If
            txtChange.Text = PaymentValue - SaleTotal
            Payment = PaymentValue.ToString
            myDisplay.ClearText()
            myDisplay.DisplayText("Change due: " & PaymentValue - SaleTotal & "    Thank You")
        End If

        If CreditCardPayment.Equals(True) Then
            Payment = txtItemInput.Text.ToString()
        End If

        ItemCount = lstITEMS.Items.Count

        'myPrinter.Open()
        'myPrinter.Claim(1000)
        'myPrinter.AsyncMode = False
        'myPrinter.DeviceEnabled = True

        myString = "SJJ Embedded Micro Solutions" + Chr(13).ToString + Chr(10).ToString
        myPrinter.PrintNormal(PrinterStation.Receipt, myString)
        myString = "Thank You for Your Business" + Chr(13).ToString + Chr(10).ToString
        myPrinter.PrintNormal(PrinterStation.Receipt, myString)

        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        For X = 0 To ItemCount - 1
            myString = lstITEMS.Items.Item(X)
            myString2 = myString.Replace("ESC", Chr(27).ToString()) + Chr(13).ToString + Chr(10).ToString
            myPrinter.PrintNormal(PrinterStation.Receipt, myString2)
        Next

        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)

        myString = "Total: $" & SaleTotal.ToString + Chr(13).ToString + Chr(10).ToString
        myPrinter.PrintNormal(PrinterStation.Receipt, myString)

        If CashPayment.Equals(True) Then
            myString = "Amount Paid: $" & PaymentValue.ToString + Chr(13).ToString + Chr(10).ToString
            myPrinter.PrintNormal(PrinterStation.Receipt, myString)
            myString = "ChangeDue: $" & txtChange.Text.ToString + Chr(13).ToString + Chr(10).ToString
            myPrinter.PrintNormal(PrinterStation.Receipt, myString)
        End If

        If CreditCardPayment.Equals(True) Then
            myString = "Account Name: " + txtCCName.Text.ToString + Chr(13).ToString + Chr(10).ToString
            myPrinter.PrintNormal(PrinterStation.Receipt, myString)
            myString = "Account Number: " & Payment.ToString + Chr(13).ToString + Chr(10).ToString
            myPrinter.PrintNormal(PrinterStation.Receipt, myString)
        End If

        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myString2 = TodaysDate + Chr(13).ToString + Chr(10).ToString
        myPrinter.PrintNormal(PrinterStation.Receipt, myString2)
        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myPrinter.PrintNormal(PrinterStation.Receipt, Chr(13).ToString + Chr(10).ToString)
        myPrinter.CutPaper(90)

        'myPrinter.DeviceEnabled = False
        'myPrinter.Release()
        'myPrinter.Close()

        'Open the cash drawer only if cash is be paid.
        If CashPayment.Equals(True) Then
            OpenCashDrawer()
        End If

    End Sub

#End Region 'POs Devices


End Class
