﻿//CashRegister_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;
using System.Data.OleDb;


namespace CashRegister_CS
{
    public partial class CashRegister : Form
    {
        //There are 5 POS devices for use with this application 
        private PosExplorer explorer;
        private Scanner myScanner;
        private Msr myMSR;
        private LineDisplay myDisplay;
        private PosPrinter myPrinter;
        private CashDrawer myCashDrawer;

        //There are the global variables. SaleTotal is used to calculate the on going
        //Sale total as items are added and removed. CashPayment and CreditCardPayment
        //are used as flags to set the state of the keypad and printout and cash drawer
        //options.

        public Decimal SaleTotal = 0;
        public Boolean CashPayment = false;
        public Boolean CreditCardPayment = false;
        

        public CashRegister()
        {
            InitializeComponent();
            explorer = new PosExplorer(this);
            explorer.DeviceAddedEvent += new DeviceChangedEventHandler(explorer_DeviceAddedEvent);
            explorer.DeviceRemovedEvent += new DeviceChangedEventHandler(explorer_DeviceRemovedEvent);

            InitializeDevices();

            lblChange.Visible = false;
            lblCCName.Visible = false;
            txtCCName.Visible = false;
            txtChange.Visible = false;
        }

        #region "Key Pad Buttons" 

        //******************************************************************************************************************
        //
        //btnEnter_Click(
        //The Enter button performs different actions depending upon the state of the system:
        //
        //Scan Items - Numbers entered for a bar code are then checked against the database
        //CashPayment - calculate change, print receipt and opening the cash draw
        //CreditCard Payment - print receipt
        //
        //
        private void btnEnter_Click(object sender, EventArgs e)
        {

            OleDbConnection dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Database\\Inventory.mdb");

            dbConnect.Open();

            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect);
            DataSet dbDataSet = new DataSet();

            dbAdapter.Fill(dbDataSet, "Inventory");

            DataTable dbDataTable = new DataTable();

            dbDataTable = dbDataSet.Tables["Inventory"];

            if(CashPayment.Equals(false) && CreditCardPayment.Equals(false))
            {
                myDisplay.ClearText();
                String myItem = txtItemInput.Text;

                foreach (DataRow row in dbDataTable.Rows)
                {
                    String ItemNo = row.Field<Int32>("ItemNo").ToString();
                    String ItemName = row.Field<string>("ItemName");
                    String BarCode = row.Field<string>("BarCode");
                    Int32 QTY = row.Field<Int32>("QTY");
                    Decimal Price = row.Field<decimal>("Price");

                    if (BarCode == myItem)
                    {
                        String myItem2 = ItemName + " $" + Price.ToString();
                        lstITEMS.Items.Add(myItem2);
                        myDisplay.DisplayText(ItemName + " $" + Price.ToString());
                        SaleTotal = SaleTotal + Price;
                        txtItemInput.Clear();
                        lblStatus.Text = "Item added";
                        break;
                    }

                }

                txtTotal.Text = SaleTotal.ToString();
            }

            //
            //Process a cash payment
            //

            if(CashPayment.Equals(true))
            {
                if (txtItemInput.Text == "")
                {
                    lblStatus.Text = "Need to enter value";
                }
                else{
                    btnCancelSale.Enabled = false;
                    SalesReceipt();
                }
            }

            //
            //Process a credit card payment
            //

            if(CreditCardPayment.Equals(true))
            {
                if (txtItemInput.Text == "")
                {
                    lblStatus.Text = "Need to enter value";
                }
                else{
                    btnCancelSale.Enabled = false;
                    SalesReceipt();
                }

            }

            dbDataTable.Clear();
            dbDataSet.Clear();
            dbConnect.Close();

        }

        //'******************************************************************************************************************
        //
        //txtItemInput_KeyPress
        //When someone types in a bar code, cash payment, or credit card number and then hits enter
        //this Subroutine performs the Enter button click and jumps to the btnEnter_Click routine
        //

        private void txtItemInput_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            //Adds item to sale with an Enter press either by Scanner or keyboard
            if(e.KeyChar == (char)13)
            {
                this.btnEnter.PerformClick();
            }
        }

        //'******************************************************************************************************************
        //
        //Key Pad Buttons
        //Use to enter numbers into the txtItemInput box - Barcodes, cash paymet, credit card numbers
        //


        private void btnNum1_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "1";
            txtItemInput.Text = tempValue;
        }
        private void btnNum2_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "2";
            txtItemInput.Text = tempValue;
        }
        private void btnNum3_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "3";
            txtItemInput.Text = tempValue;
        }
        private void btnNum4_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "4";
            txtItemInput.Text = tempValue;
        }
        private void btnNum5_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "5";
            txtItemInput.Text = tempValue;
        }
        private void btnNum6_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "6";
            txtItemInput.Text = tempValue;
        }
        private void btnNum7_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "7";
            txtItemInput.Text = tempValue;
        }
        private void btnNum8_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "8";
            txtItemInput.Text = tempValue;
        }
        private void btnNum9_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "9";
            txtItemInput.Text = tempValue;
        }
        private void btnNum0_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + "0";
            txtItemInput.Text = tempValue;
        }
        private void btnNumDot_Click(object sender, EventArgs e)
        {
            String tempValue;
            tempValue = txtItemInput.Text;
            tempValue = tempValue + ".";
            txtItemInput.Text = tempValue;
        }

        //******************************************************************************************************************
        //
        //btnClear_Click
        //Clears the txtItemInput text box - quick clear solution
        //
        private void btnClear_Click(object sender, EventArgs e)
        {
            //Clear the Input
            txtItemInput.Clear();
        }

        //******************************************************************************************************************
        //
        //btnBack_Click
        //Provides back space functionality
        //
        private void btnBack_Click(object sender, EventArgs e)
        {
            String tempItem;
            int tempItemIndex;

            tempItem = txtItemInput.Text;
            tempItemIndex = tempItem.Length;

            if (tempItemIndex > 0)
            {
                txtItemInput.Text = tempItem.Substring(0, tempItemIndex - 1);
            }
        }

        #endregion //"Key Pad Buttons"


        #region "Functional Buttons"

        //******************************************************************************************************************
        //
        //btnCancelSale_Click
        //Clears out the current sale and state
        //
        private void btnCancelSale_Click(object sender, EventArgs e)
        {
            lstITEMS.Items.Clear();
            myDisplay.ClearText();
            myDisplay.DisplayText("Sale cancelled");
            txtTotal.Text = (0.0).ToString();
            SaleTotal = 0;
            cmdRemove.Enabled = true;
            lblStatus.Text = "Sale cancelled";
            lblState.Text = "Enter Item Number";
            lblChange.Visible = false;
            lblCCName.Visible = false;
            txtCCName.Visible = false;
            txtChange.Visible = false;
            txtItemInput.Text = "";
            txtCCName.Text = "";
            txtChange.Text = "";
            CashPayment = false;
            CreditCardPayment = false;
        }

        //'******************************************************************************************************************
        //
        //btnNewSale_Click
        //Press this button after a sale has been competed
        //
        private void btnNewSale_Click(object sender, EventArgs e)
        {
            lstITEMS.Items.Clear();
            myDisplay.ClearText();
            myDisplay.DisplayText("Welcome");
            txtTotal.Text = (0.0).ToString();
            SaleTotal = 0;
            cmdRemove.Enabled = true;
            lblStatus.Text = "Ready";
            lblState.Text = "Enter Item Number";
            lblChange.Visible = false;
            lblCCName.Visible = false;
            txtCCName.Visible = false;
            txtChange.Visible = false;
            txtItemInput.Text = "";
            txtCCName.Text = "";
            txtChange.Text = "";
            CashPayment = false;
            CreditCardPayment = false;
        }

        //******************************************************************************************************************
        //
        //cmdRemove_Click
        //Removes an item from the list. Because teh lsit is only containing text, the database is required to 
        //create a comparison so when the item is removed, the SaleTotal can be updated.
        //

        private void cmdRemove_Click(object sender, EventArgs e)
        {
            myDisplay.ClearText();
            int ListItemIndex = lstITEMS.SelectedIndex;
                        
            OleDbConnection dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Database\\Inventory.mdb");

            dbConnect.Open();

            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect);
            DataSet dbDataSet = new DataSet();

            dbAdapter.Fill(dbDataSet, "Inventory");

            DataTable dbDataTable = new DataTable();

            dbDataTable = dbDataSet.Tables["Inventory"];

            if (ListItemIndex >= 0)
            {
                foreach (DataRow row in dbDataTable.Rows)
                {
                    String ItemNo = row.Field<Int32>("ItemNo").ToString();
                    String ItemName = row.Field<string>("ItemName");
                    String BarCode = row.Field<string>("BarCode");
                    Int32 QTY = row.Field<Int32>("QTY");
                    Decimal Price = row.Field<decimal>("Price");
                    //The item list is a combination of the ItemName and price 
                    //So we need a string to copare too.
                    String myItem = ItemName + " $" + Price.ToString();

                    //Once the item is found it is removed from the list and the SaleTotl
                    //is updated
                    if (lstITEMS.SelectedItem.ToString() == myItem)
                    {
                        myDisplay.DisplayText(ItemName + " Removed");
                        SaleTotal = SaleTotal - Price;
                        lstITEMS.Items.RemoveAt(ListItemIndex);
                        break;
                    }
                }
            }

            //Update the total Sale
            txtTotal.Text = SaleTotal.ToString();
            lblStatus.Text = "Item removed";       

            dbDataTable.Clear();
            dbDataSet.Clear();
            dbConnect.Close();
        }

        //******************************************************************************************************************
        //
        //btnCash_Click
        //When the Cash button is pressed, this is the start of the sales process. The keypad entery changes so the 
        //txtItemInput is an entery for cash receive, a change box appears so the clerk can see the change do
        //The global setting for CashPayment is set to true, which will direct the Enter button to take the 
        //appropriate acction.
        //

        private void btnCash_Click(object sender, EventArgs e)
        {
            CashPayment = true;
            cmdRemove.Enabled = false;
            lblState.Text = "Enter cash received:";
            lblChange.Visible = true;
            txtChange.Visible = true;
        }

        //******************************************************************************************************************
        //
        //btnCheck_Click
        //Does nothing. If there was a check reader attached this code could be filled in
        //
        private void btnCheck_Click(object sender, EventArgs e)
        {
            lblStatus.Text = "Sorry No Checks";
            myDisplay.ClearText();
            myDisplay.DisplayText("Sorry No Checks Accepted");
        }
       
        //******************************************************************************************************************
        //
        //btnCreditCard_Click
        //When the Credit Card button is pressed, this is the start of the sales process. The keypad entery changes so the 
        //txtItemInput is an entery for credit card entry, A Name box appears so when the card is swiped 
        //the database result will show the correct card carriers name to check against the card.
        //The global setting for CreditCardPayment is set to true, which will direct the Enter button to take the 
        //appropriate acction. This routine will also open the MSR.
        //
        private void btnCreditCard_Click(object sender, EventArgs e)
        {
            lblState.Text = "Slide Credit Card";
            CashPayment = false;
            CreditCardPayment = true;
            lblCCName.Visible = true;
            txtCCName.Visible = true;
            cmdRemove.Enabled = false;

            myMSR.Open();
            myMSR.Claim(1000);
            myMSR.DeviceEnabled = true;
            myMSR.DataEventEnabled = true;
            myMSR.DecodeData = true;
        }

        #endregion //"Functional Buttons"


        #region "POS Devices"

        //******************************************************************************************************************
        //
        //InitializeDevices
        //Here we initialize the different POS devices. Assuming that the logical names have been setup correctly,
        //a create isntance of the five device will be performed. If there is a device missing or not functional, the Status box
        //will list the missing devices. 
        //The line display and the SCanner are the only two devices that need to be opended and enabled. The others
        //will be opened, claimed, and enabled as there are needed.

        private void InitializeDevices()
        {
            String DeviceStr = "";
            Boolean eFlag = false;

            //Poll Display setup
            //If the display is not attached it cannot be claimed. An exception will pop
            //if we don't have the try-catch in place. The Try Catch will be used for all
            //5 POS devices

            try
            {
                DeviceInfo device = explorer.GetDevice("LineDisplay");                            
                myDisplay = (LineDisplay)explorer.CreateInstance(device);
                myDisplay.Open();
                myDisplay.Claim(1000);
                myDisplay.DeviceEnabled = true;
                myDisplay.ClearText();
                myDisplay.DisplayText("SJJ EMS              POS for .NET");
            }
            catch 
            {
                DeviceStr = DeviceStr + " LineDisplay";
                eFlag = true;
            }

            //Now lets get the Printer
            try
            {
                DeviceInfo device2 = explorer.GetDevice("PosPrinter");
                myPrinter = (PosPrinter)explorer.CreateInstance(device2);
                myPrinter.Open();
                myPrinter.Claim(1000);
                myPrinter.AsyncMode = false;
                myPrinter.DeviceEnabled = true;
            }
            catch
            {
                DeviceStr = DeviceStr + " Printer";
                eFlag = true;
            }

            //Get the Cash Drawer
            try
            {
                DeviceInfo device3 = explorer.GetDevice("CashDrawer");
                myCashDrawer = (CashDrawer)explorer.CreateInstance(device3);
            }
            catch
            {
                DeviceStr = DeviceStr + " Cash Drawer";
                eFlag = true;
            }

            //Connect the MSR
            try
            {
                DeviceInfo device4 = explorer.GetDevice("Msr", "myMSR");
                myMSR = (Msr)explorer.CreateInstance(device4);
                myMSR.DataEvent += new DataEventHandler(myMSR_DataEvent);
                myMSR.ErrorEvent += new DeviceErrorEventHandler(myMSR_ErrorEvent);
            }
            catch
            {
                DeviceStr = DeviceStr + " MSR";
                eFlag = true;
            }

            //Finally, connect the Bar Code Scanner
            try
            {
                DeviceInfo device5 = explorer.GetDevice("Scanner", "myScanner");
                myScanner = (Scanner)explorer.CreateInstance(device5);

                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);
                myScanner.ErrorEvent += new DeviceErrorEventHandler(myScanner_ErrorEvent);
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;
            }
            catch
            {
                DeviceStr = DeviceStr + " Scanner";
                eFlag = true;
            }

            if (eFlag.Equals(true))
            {
                lblStatus.Text = "No" + DeviceStr + " Attached - Reconnect or Replace";
            }
            else
            {
                lblStatus.Text = "Ready";
            }

        }


        //******************************************************************************************************************
        //
        //explorer_DeviceRemoveEvent
        //explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
        //Here we will check to see what devices were removed added and display to the line display and status box
        //
        //

        void explorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            
             //Close out the scanner
            if (e.Device.Type == "Scanner"){

                myDisplay.ClearText();
                myDisplay.DisplayText("Bar-code scanner removed");
                lblStatus.Text = "Bar-code scanner removed";
                myScanner.DecodeData = false;
                myScanner.DataEventEnabled = false;
                myScanner.DeviceEnabled = false;
                myScanner.Release();
                myScanner.Close();
                Update();
            }
            //Close out the MSR
            if (e.Device.Type == "Msr")
            {
                myDisplay.ClearText();
                myDisplay.DisplayText("Msr removed");
                lblStatus.Text = "Msr removed";
                myMSR.DataEventEnabled = false;
                myMSR.DecodeData = false;
                myMSR.Release();
                myMSR.Close();
                lblStatus.Text = "Msr Detached";
                Update();
            }
        }

        //'******************************************************************************************************************
        //
        //explorer_DeviceAddedEvent
        //explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
        //Here we will check to see what devices were added and display to the line display and status box
        //
        void explorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
             //Since the scanner is used from the onset, we imediately open the scanner.
            if (e.Device.Type == "Scanner")
            {           
                myScanner = (Scanner)explorer.CreateInstance(e.Device);
                myDisplay.ClearText();
                myDisplay.DisplayText("New bar-code scanner attached");
                lblStatus.Text = "New bar-code scanner attached: " + e.Device.ServiceObjectName;
                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);
                myScanner.ErrorEvent += new DeviceErrorEventHandler(myScanner_ErrorEvent);
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;            
            }

             //We only use the MSR when there is a credit card payment
             //We only need to create and instance of the device. The MSR will be opened later

            if (e.Device.Type == "Msr")
            {            
                myMSR = (Msr)explorer.CreateInstance(e.Device);
                myDisplay.ClearText();
                myDisplay.DisplayText("New MSR attached");
                lblStatus.Text = "New Msr attached: " + e.Device.ServiceObjectName;                
            }
        }

        //******************************************************************************************************************
        //
        //MyScanner_DataEvent
        //As we scan items, the barcode that was just scanned will then be checked against the database. If an item
        //is found it will then be listed in the list box and the SaleTotal will e udpated. This code could be combined with the 
        //Enter button to compact the code listing - this will be left up to the reader.
        //
        void myScanner_DataEvent(object sender, DataEventArgs e)
        {

            ASCIIEncoding myEncoding = new ASCIIEncoding();
            String myScan = myEncoding.GetString(myScanner.ScanDataLabel);
            OleDbConnection dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Database\\Inventory.mdb");

            dbConnect.Open();

            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect);
            DataSet dbDataSet = new DataSet();

            dbAdapter.Fill(dbDataSet, "Inventory");

            DataTable dbDataTable = new DataTable();

            dbDataTable = dbDataSet.Tables["Inventory"];

            myDisplay.ClearText();

            foreach (DataRow row in dbDataTable.Rows)
            {

                String ItemNo = row.Field<Int32>("ItemNo").ToString();
                String ItemName = row.Field<string>("ItemName");
                String BarCode = row.Field<string>("BarCode");
                Int32 QTY = row.Field<Int32>("QTY");
                Decimal Price = row.Field<decimal>("Price");

                if (BarCode == myScan)
                {
                    String myItem2 = ItemName + " $" + Price.ToString();
                    lstITEMS.Items.Add(myItem2);
                    myDisplay.DisplayText(ItemName + " $" + Price.ToString());
                    SaleTotal = SaleTotal + Price;
                    txtItemInput.Clear();
                    lblStatus.Text = "Item added";
                    break;
                }
            }

            txtTotal.Text = SaleTotal.ToString();
            dbDataTable.Clear();
            dbDataSet.Clear();
            dbConnect.Close();
            myScanner.DataEventEnabled = true;
        }

       //******************************************************************************************************************
       //
       //myScanner_ErrorEvent
       //If there is an error scanning the item, then indicate this on the Status Box, and re-enable the 
       //scanner data event - don't leave the scanner disabled or someone will think the scanner
       //went bad.
       //

        void myScanner_ErrorEvent(object sender, DeviceErrorEventArgs e)
        {
            lblStatus.Text = "Error with card";        
            myScanner.DataEventEnabled = true;
        }

        //******************************************************************************************************************
        //
        //OpenCashDrawer
        //Seperate subroutine to open the WASP 5000 cash drawer. One could add a button to open the cash drawer
        //independent of the sales process.
        //
        void OpenCashDrawer()
        {
            myCashDrawer.Open();
            myCashDrawer.Claim(1000);
            myCashDrawer.DeviceEnabled = true;
            myCashDrawer.OpenDrawer();
            myCashDrawer.DeviceEnabled = false;
            myCashDrawer.Release();
            myCashDrawer.Close();

            lblStatus.Text = "Cash Drawer Open";
        }

        //******************************************************************************************************************
        //
        //myMSR_DataEvent
        //When the Credit Card button is pressed, the MSR is the opened, claimed, and enabled for reading a card
        //This routine checks the msrData Track 2 against a database of credit cards to see if the card is valid
        //If it is valid, the sale will be processed; if not it will be denied. Of course, the code would really call
        //back into the credit card company for verification. Accessing a local database is just for demonstration
        //
        void myMSR_DataEvent(object sender, DataEventArgs e)
        {
            
                        ASCIIEncoding myEncoding = new ASCIIEncoding();
            String msrData;
            //bool InvCard = true;

            msrData = myEncoding.GetString(myMSR.Track2Data);

            OleDbConnection dbConnect;
            OleDbCommand dbCommand;
            OleDbDataReader dbReader;

            dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\\Database\\POS_ID.mdb");
            dbConnect.Open();
            dbCommand = new OleDbCommand("SELECT EmployeeID, Name, BadgeNumber, Access FROM Employees", dbConnect);
            dbReader = dbCommand.ExecuteReader();

            while (dbReader.Read())
            {
                String strID = dbReader.GetInt32(0).ToString();
                String Name = dbReader.GetString(1);
                String Badge = dbReader.GetString(2);
                Boolean Access = dbReader.GetBoolean(3);

                if (Badge == msrData)
                {

                    txtItemInput.Text = msrData;
                    if (Access.Equals(true))
                    {
                        txtCCName.Text = Name;
                        lblStatus.Text = "Card OK";
                        myDisplay.ClearText();
                        myDisplay.DisplayText("Card OK");
                        btnCancelSale.Enabled = false;
                        SalesReceipt();
                        myMSR.DataEventEnabled = false;
                        myMSR.DecodeData = false;
                        myMSR.Release();
                        myMSR.Close();
                        break;
                    }
                    else
                    {
                        lblStatus.Text = "Invalid Card - Try again";
                        break;

                    }
                }       

            }

            dbReader.Close();
            dbReader = null;
            dbConnect.Close();
            dbConnect = null;
            myMSR.DataEventEnabled = true;
        }

       //******************************************************************************************************************
       //
       //myMSR_ErrorEvent
       //Like the scanner, the myMSR_ErrorEvent indicates to the user that an error occured and re-enables the device
       //

        void myMSR_ErrorEvent(object sender, DeviceErrorEventArgs e)
        {
            lblStatus.Text = "Error with card";
            myMSR.DataEventEnabled = true;
        }

        //******************************************************************************************************************
        //
        //SalesReceipt
        //Processes the sale. If cash payment calculate the change; if credit card list the number in the text box - 
        //Open the printer and print out the appropriate information based on CAshPayment and CreditCardPayent flags
        //Close the printer when finished.
        //
        void SalesReceipt()
        {

            int ItemCount;
            int X;
            String myString;
            String myString2;
            String TodaysDate = DateTime.Now.ToString();

            String Payment = "";
            Decimal PaymentValue = 0;

            if (CashPayment.Equals(true))
            {
                PaymentValue =  Decimal.Parse(txtItemInput.Text.ToString());
                if (SaleTotal > PaymentValue)
                {
                    lblStatus.Text = "Wrong Cash Amount";
                }
                txtChange.Text = (PaymentValue - SaleTotal).ToString();
                Payment = PaymentValue.ToString();
                myDisplay.ClearText();
                myDisplay.DisplayText("Change due: " + (PaymentValue - SaleTotal).ToString() + "    Thank You");
            }

            if (CreditCardPayment.Equals(true))
            {
                Payment = txtItemInput.Text.ToString();
            }
            
            ItemCount = lstITEMS.Items.Count;

            //myPrinter.Open();
            //myPrinter.Claim(1000);
            //myPrinter.AsyncMode = false;
            //myPrinter.DeviceEnabled = true;

            myString = "SJJ Embedded Micro Solutions" + ((char)13).ToString() + ((char)10).ToString();
            myPrinter.PrintNormal(PrinterStation.Receipt, myString);
            myString = "Thank You for Your Business" + ((char)13).ToString() + ((char)10).ToString();
            myPrinter.PrintNormal(PrinterStation.Receipt, myString);

            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());

            for (X = 0; X < ItemCount; X++)
            {
                myString = lstITEMS.Items[X].ToString();
                myString2 = myString.Replace("ESC", ((char)27).ToString()) + ((char)13).ToString() + ((char)10).ToString();
                myPrinter.PrintNormal(PrinterStation.Receipt, myString2);
            }

            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myString = "Total: $" + SaleTotal.ToString() + ((char)13).ToString() + ((char)10).ToString();
            myPrinter.PrintNormal(PrinterStation.Receipt, myString);

            if (CashPayment.Equals(true))
            {
                myString = "Amount Paid: $" + PaymentValue.ToString() + ((char)13).ToString() + ((char)10).ToString();
                myPrinter.PrintNormal(PrinterStation.Receipt, myString);
                myString = "ChangeDue: $" + txtChange.Text.ToString() + ((char)13).ToString() + ((char)10).ToString();
                myPrinter.PrintNormal(PrinterStation.Receipt, myString);
            }

            if (CreditCardPayment.Equals(true))
            {
                myString = "Account Name: " + txtCCName.Text.ToString() + ((char)13).ToString() + ((char)10).ToString();
                myPrinter.PrintNormal(PrinterStation.Receipt, myString);
                myString = "Account Number: " + Payment.ToString() + ((char)13).ToString() + ((char)10).ToString();
                myPrinter.PrintNormal(PrinterStation.Receipt, myString);
            }

            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myString2 = TodaysDate + ((char)13).ToString() + ((char)10).ToString();
            myPrinter.PrintNormal(PrinterStation.Receipt, myString2);
            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myPrinter.PrintNormal(PrinterStation.Receipt, ((char)13).ToString() + ((char)10).ToString());
            myPrinter.CutPaper(90);

            //myPrinter.DeviceEnabled = False
            //myPrinter.Release()
            //myPrinter.Close()

            //Open the cash drawer only if cash is be paid.
            if (CashPayment.Equals(true))
            {
                OpenCashDrawer();
            }

        }


        #endregion //"POS Devices"


    }
}
