﻿'Inventory
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'

Imports Microsoft.PointOfService
Imports System.Text
Imports System.Data
Imports System.Data.OleDb
Imports System.Data.SqlClient

Public Class frmMain
    WithEvents myExplore As PosExplorer
    WithEvents myScanner As Scanner


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'InventoryDataSet.Inventory' table. You can move, or remove it, as needed.
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub

    Private Sub btnReferesh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReferesh.Click
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)
    End Sub

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myExplore = New PosExplorer(Me)
        Dim device As DeviceInfo = myExplore.GetDevice("Scanner", "myScanner")


        Try
            myScanner = myExplore.CreateInstance(device)
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
        Catch ex As Exception
            lblStatus.Text = "No Scanner Attached - Reconnect or Replace"

        End Try


        Update()
    End Sub

    Private Sub myExplore_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceAddedEvent
        If (e.Device.Type = "Scanner") Then
            myScanner = myExplore.CreateInstance(e.Device)

            lblStatus.Text = "New bar-code scanner attached"

            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
            Update()
        End If
    End Sub

    Private Sub myExplore_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceRemovedEvent
        If (e.Device.Type = "Scanner") Then

            lblStatus.Text = "Bar-code scanner detached"

            myScanner.DataEventEnabled = False
            myScanner.DeviceEnabled = False
            myScanner.Release()
            myScanner.Close()
            Update()

        End If
    End Sub

    Private Sub myScanner_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myScanner.DataEvent
        Dim myEncoding As New ASCIIEncoding
        Dim myScan As String = myEncoding.GetString(myScanner.ScanDataLabel)
        Dim dbConnect As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Database\Inventory.mdb")
        Dim rowIndex As Integer = 0

        dbConnect.Open()

        Dim dbAdapter As New OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect)
        Dim dbDataSet As New DataSet

        dbAdapter.Fill(dbDataSet, "Inventory")

        Dim dbTable As DataTable = dbDataSet.Tables("Inventory")

        If rbNone.Checked.Equals(True) Or rbIncrement.Checked.Equals(True) Or rbDecrement.Checked.Equals(True) Or rbDelete.Checked.Equals(True) Then

            For Each row As DataRow In dbTable.Rows
                Dim ItemNo As String = row("ItemNo").ToString()
                Dim ItemName As String = row("ItemName").ToString()
                Dim BarCode As String = row("BarCode").ToString()
                Dim QTY As Integer = row("QTY").ToString()
                Dim Price As String = row("Price").ToString()

                If BarCode = myScan Then

                    txtProductName.Text = ItemName
                    If rbNone.Checked.Equals(True) Then

                        txtPrice.Text = Price
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        lblStatus.Text = "Ready"
                        Exit For

                    ElseIf rbIncrement.Checked.Equals(True) Then

                        Dim dbCommandBuilder As New OleDb.OleDbCommandBuilder(dbAdapter)
                        dbCommandBuilder.GetUpdateCommand()
                        QTY = QTY + 1
                        txtQTY.Text = QTY.ToString
                        row("QTY") = QTY
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        txtPrice.Text = Price
                        lblStatus.Text = "QTY increased"
                        dbAdapter.Update(dbDataSet, "Inventory")

                        Exit For

                    ElseIf rbDecrement.Checked.Equals(True) Then

                        Dim dbCommandBuilder As New OleDb.OleDbCommandBuilder(dbAdapter)
                        dbCommandBuilder.GetUpdateCommand()
                        QTY = QTY - 1
                        txtQTY.Text = QTY.ToString
                        row("QTY") = QTY
                        txtQTY.Text = QTY.ToString
                        txtScanTrack2.Text = BarCode
                        txtPrice.Text = Price
                        lblStatus.Text = "QTY decreased"
                        dbAdapter.Update(dbDataSet, "Inventory")

                        Exit For


                    ElseIf rbDelete.Checked.Equals(True) Then

                        If MessageBox.Show("Do you want to delete this item?", "Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) = DialogResult.Yes Then
                            Dim dbCommandBuilder As New OleDb.OleDbCommandBuilder(dbAdapter)
                            dbCommandBuilder.GetUpdateCommand()
                            dbDataSet.Tables("Inventory").Rows(rowIndex).Delete()
                            dbAdapter.Update(dbDataSet, "Inventory")
                            txtProductName.Text = ""
                            txtPrice.Text = ""
                            txtQTY.Text = ""
                            txtScanTrack2.Text = ""
                            lblStatus.Text = "Item Removed"
                        Else
                            lblStatus.Text = "Delete Item Cancelled"

                        End If

                        Exit For
                    End If


                End If

                rowIndex += 1

            Next

        ElseIf rbAdd.Checked.Equals(True) Then

            txtPrice.Text = ""
            txtProductName.Text = ""
            txtScanTrack2.Text = myScan
            txtQTY.Text = "1"

        End If


        Update()

        dbTable.Clear()
        dbDataSet.Clear()
        dbConnect.Close()

        myScanner.DataEventEnabled = True
        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub

    Private Sub rbAdd_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbAdd.CheckedChanged
        If rbAdd.Checked.Equals(True) Then
            btnAdd.Enabled = True

        ElseIf rbAdd.Checked.Equals(False) Then
            btnAdd.Enabled = False

        End If
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim dbConnect As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Database\Inventory.mdb")

        dbConnect.Open()

        Dim dbAdapter As New OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect)
        Dim dbDataSet As New DataSet

        dbAdapter.Fill(dbDataSet, "Inventory")

        If txtProductName.Text = "" Or txtPrice.Text = "" Or txtScanTrack2.Text = "" Or txtQTY.Text = "" Then
            lblStatus.Text = "Need to fill in all fields"
        Else
            Dim dbCommandBuilder As New OleDb.OleDbCommandBuilder(dbAdapter)
            dbCommandBuilder.GetUpdateCommand()
            Dim dbNewRow As DataRow

            dbNewRow = dbDataSet.Tables("Inventory").NewRow()
            dbNewRow.Item("ItemName") = txtProductName.Text.ToString()
            dbNewRow.Item("BarCode") = txtScanTrack2.Text.ToString()
            dbNewRow.Item("QTY") = txtQTY.Text.ToString()
            dbNewRow.Item("Price") = txtPrice.Text.ToString()

            dbDataSet.Tables("Inventory").Rows.Add(dbNewRow)

            dbAdapter.Update(dbDataSet, "Inventory")

            lblStatus.Text = txtProductName.Text.ToString & " added to database"
            btnAdd.Enabled = False
        End If


        dbDataSet.Clear()
        dbConnect.Close()


        Me.InventoryTableAdapter.Fill(Me.InventoryDataSet.Inventory)

    End Sub
End Class
