﻿//Inventory_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;
using System.Data.OleDb;


namespace Inventory_CS
{
    public partial class frmMain : Form
    {
        private PosExplorer myPosExplorer;
        private Scanner myScanner;
        
        public frmMain()
        {
            InitializeComponent();
            myPosExplorer = new PosExplorer(this);
            myPosExplorer.DeviceAddedEvent += new DeviceChangedEventHandler(myPosExplorer_DeviceAddedEvent);
            myPosExplorer.DeviceRemovedEvent += new DeviceChangedEventHandler(myPosExplorer_DeviceRemovedEvent);
            DeviceInfo device = myPosExplorer.GetDevice("Scanner", "myScanner");
            
            if (device == null)
            {
                
                lblStatus.Text = "Scanner not found";
            }
            else
            {
                myScanner = (Scanner)myPosExplorer.CreateInstance(device);
                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;
            }            
        }
        
        private void frmMain_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'inventoryDataSet.Inventory' table. You can move, or remove it, as needed.
            this.inventoryTableAdapter.Fill(this.inventoryDataSet.Inventory);
        }

        private void btnReferesh_Click(object sender, EventArgs e)
        {
            this.inventoryTableAdapter.Fill(this.inventoryDataSet.Inventory);
        }

        void myPosExplorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Scanner")            
            {
                myScanner.DataEventEnabled = false;
                myScanner.DeviceEnabled = false;
                myScanner.Release();
                myScanner.Close();
                lblStatus.Text = "Scanner removed";
            }
        
        }

        void myPosExplorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Scanner")
            {
                myScanner = (Scanner)myPosExplorer.CreateInstance(e.Device);
                myScanner.Open();
                myScanner.Claim(1000);
                myScanner.DataEvent += new DataEventHandler(myScanner_DataEvent);
                myScanner.DeviceEnabled = true;
                myScanner.DataEventEnabled = true;
                myScanner.DecodeData = true;
                lblStatus.Text = "Scanner Attached";
            }
        }

        void myScanner_DataEvent(object sender, DataEventArgs e)
        {
            ASCIIEncoding myEncoding = new ASCIIEncoding();
            String myScan = myEncoding.GetString(myScanner.ScanDataLabel);
            OleDbConnection dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Database\\Inventory.mdb");
            int rowIndex = 0;

            dbConnect.Open();

            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect);
            DataSet dbDataSet = new DataSet();

            dbAdapter.Fill(dbDataSet, "Inventory");
                        
            DataTable dbDataTable  = new DataTable();
                
            dbDataTable =  dbDataSet.Tables["Inventory"];                     
          
            if(rbNone.Checked.Equals(true) | rbIncrement.Checked.Equals(true) | rbDecrement.Checked.Equals(true) | rbDelete.Checked.Equals(true))
            {
            
                foreach (DataRow row in dbDataTable.Rows)
                {

                    String ItemNo = row.Field<Int32>("ItemNo").ToString();
                    String ItemName = row.Field<string>("ItemName");
                    String BarCode = row.Field<string>("BarCode");
                    Int32 QTY = row.Field<Int32>("QTY");
                    Decimal Price = row.Field<decimal>("Price");

                    if (BarCode == myScan)
                    {
                        txtProductName.Text = ItemName;
                        if (rbNone.Checked.Equals(true))
                        {
                            txtPrice.Text = Price.ToString();
                            txtQTY.Text = QTY.ToString();
                            txtScanTrack2.Text = BarCode;
                            lblStatus.Text = "Ready";
                            break;
                        }

                        if (rbIncrement.Checked.Equals(true))
                        {
                            
                            OleDbCommandBuilder dbCommandBuilder = new OleDbCommandBuilder(dbAdapter);
                            dbCommandBuilder.GetUpdateCommand();
                            QTY += 1;
                            txtQTY.Text = QTY.ToString();                            
                            row.SetField<Int32>("QTY", QTY);                            
                            txtQTY.Text = QTY.ToString();
                            txtScanTrack2.Text = BarCode;
                            txtPrice.Text = Price.ToString();
                            lblStatus.Text = "QTY increased";
                            dbAdapter.Update(dbDataSet, "Inventory");
                            break;

                        }
                        if(rbDecrement.Checked.Equals(true))
                        {
                            OleDbCommandBuilder dbCommandBuilder = new OleDbCommandBuilder(dbAdapter);
                            dbCommandBuilder.GetUpdateCommand();
                            QTY -= 1;
                            txtQTY.Text = QTY.ToString();
                            row.SetField<Int32>("QTY", QTY);                            
                            txtQTY.Text = QTY.ToString();
                            txtScanTrack2.Text = BarCode;
                            txtPrice.Text = Price.ToString();
                            lblStatus.Text = "QTY decreased";
                            dbAdapter.Update(dbDataSet, "Inventory");
                            break;
                        }

                        if(rbDelete.Checked.Equals(true))
                        {
                            if (MessageBox.Show("Do you want to delete this item?", "Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes )
                            {
                                OleDbCommandBuilder dbCommandBuilder = new OleDbCommandBuilder(dbAdapter);
                                dbCommandBuilder.GetUpdateCommand();
                                dbDataSet.Tables["Inventory"].Rows[rowIndex].Delete();
                                dbAdapter.Update(dbDataSet, "Inventory");
                                txtProductName.Text = "";
                                txtPrice.Text = "";
                                txtQTY.Text = "";
                                txtScanTrack2.Text = "";
                                lblStatus.Text = "Item Removed";
                            }
                            else
                            {
                                lblStatus.Text = "Delete Item Cancelled";
                            }
                            break;
                        }
                    }

                    rowIndex ++;

                }            
            }
            else if(rbAdd.Checked.Equals(true))
            {
                txtScanTrack2.Text = myScan;
                txtQTY.Text = "1";

            }

            dbDataTable.Clear();
            dbDataSet.Clear();
            dbConnect.Close();

            myScanner.DataEventEnabled = true;
            this.inventoryTableAdapter.Fill(this.inventoryDataSet.Inventory);
        }

        private void rbAdd_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAdd.Checked.Equals(true))
            {
                btnAdd.Enabled = true;
            }
            else if(rbAdd.Checked.Equals(false))
            {
                btnAdd.Enabled = false;
            }
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {

            OleDbConnection dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Database\\Inventory.mdb");
            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("SELECT ItemNo, ItemName, BarCode, QTY, Price FROM Inventory", dbConnect);
            DataSet dbDataSet = new DataSet();

            dbAdapter.Fill(dbDataSet, "Inventory");

            if (txtProductName.Text == "" | txtPrice.Text == "" | txtScanTrack2.Text == "" | txtQTY.Text == "")
            {
                lblStatus.Text = "Need to fill in all fields";
            }
            else
            {
                OleDbCommandBuilder dbCommandBuilder = new OleDbCommandBuilder(dbAdapter);
                dbCommandBuilder.GetUpdateCommand();
                DataRow dbNewRow;

                dbNewRow = dbDataSet.Tables["Inventory"].NewRow();
                dbNewRow.SetField<string>("ItemName", txtProductName.Text.ToString());
                dbNewRow.SetField<string>("BarCode", txtScanTrack2.Text.ToString());
                dbNewRow.SetField<Int32>("QTY", Int32.Parse(txtQTY.Text.ToString()));
                dbNewRow.SetField<decimal>("Price", Decimal.Parse(txtPrice.Text.ToString()));

                dbDataSet.Tables["Inventory"].Rows.Add(dbNewRow);
                dbAdapter.Update(dbDataSet, "Inventory");

                lblStatus.Text = txtProductName.Text.ToString() + " added to database";
                btnAdd.Enabled = false;
            }
            
            dbDataSet.Clear();
            dbConnect.Close();            

            this.inventoryTableAdapter.Fill(this.inventoryDataSet.Inventory);
        }


    }
}
