﻿'SecurityMSR
'
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'


Imports System.Data
Imports System.Data.OleDb
Imports System.Text
Imports Microsoft.PointOfService
Imports System.Windows.Threading

Class MainWindow
    WithEvents myExplore As PosExplorer
    WithEvents myMSR As Msr

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myExplore = New PosExplorer()

        Dim Device As DeviceInfo = myExplore.GetDevice("Msr", "myMSR")

        Try
            myMSR = myExplore.CreateInstance(Device)
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            txtEmployeeName.Text = "Ready"
        Catch ex As Exception
            txtEmployeeName.Text = "No MSR Attached - Reconnect or Replace"
        End Try
        elpAccessDenied.Visibility = Windows.Visibility.Hidden
        lblAccessDenied.Visibility = Windows.Visibility.Hidden
        elpAccessGranted.Visibility = Windows.Visibility.Hidden
        lblAccessGranted.Visibility = Windows.Visibility.Hidden

    End Sub

    Private Sub myExplore_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceAddedEvent
        If (e.Device.Type = "Msr") Then
            myMSR = myExplore.CreateInstance(e.Device)
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            Dispatcher.BeginInvoke(DispatcherPriority.Normal, New Action(AddressOf MSRAttached))
        End If
    End Sub

    Private Sub myExplore_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceRemovedEvent
        If (e.Device.Type = "Msr") Then
            myMSR.DataEventEnabled = False
            myMSR.DecodeData = False
            myMSR.Release()
            myMSR.Close()

            Dispatcher.BeginInvoke(DispatcherPriority.Normal, New Action(AddressOf MSRDetached))

        End If
    End Sub


    Private Sub MSRDetached()
        txtEmployeeName.Text() = "Msr Detached"
        elpAccessDenied.Visibility = Windows.Visibility.Hidden
        lblAccessDenied.Visibility = Windows.Visibility.Hidden
        elpAccessGranted.Visibility = Windows.Visibility.Hidden
        lblAccessGranted.Visibility = Windows.Visibility.Hidden

    End Sub

    Private Sub MSRAttached()
        txtEmployeeName.Text = "New Msr attached"
    End Sub

    Private Sub myMSR_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myMSR.DataEvent
        Dim myEncode As New ASCIIEncoding
        Dim msrData As String
        Dim InvCard As Boolean = True 'Test for an invalid card condition

        msrData = myEncode.GetString(myMSR.Track2Data)

        Dim dbConnect As New OleDbConnection
        Dim dbCommand As New OleDbCommand
        Dim dbreader As OleDbDataReader

        dbConnect = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Database\POS_ID.mdb")
        dbConnect.Open()
        dbCommand = New OleDbCommand("SELECT EmployeeID, Name, BadgeNumber, Access FROM Employees", dbConnect)
        dbreader = dbCommand.ExecuteReader

        While dbreader.Read
            Dim strID As String = CStr(dbreader("EmployeeID"))
            Dim Name As String = dbreader("Name")
            Dim Badge As String = dbreader("BadgeNumber")
            Dim Access As Boolean = dbreader("Access")
            'Display the user name of the card and then display their access
            If Badge = msrData Then

                If Access.Equals(True) Then
                    Dispatcher.BeginInvoke(DispatcherPriority.Normal, New AccessGrantedDelegate(AddressOf AccessGranted), Name)
                    InvCard = False
                    Exit While
                Else
                    Dispatcher.BeginInvoke(DispatcherPriority.Normal, New AccessGrantedDelegate(AddressOf AccessDenied), Name)
                    InvCard = False
                    Exit While
                End If
            End If

        End While
        'If the card is invalid, let the user know
        If InvCard.Equals(True) Then
            Dispatcher.BeginInvoke(DispatcherPriority.Normal, New Action(AddressOf InvalidCard))
        End If

        dbreader.Close()
        dbreader = Nothing
        dbConnect.Close()
        dbConnect = Nothing
        myMSR.DataEventEnabled = True


    End Sub

    Private Delegate Sub AccessGrantedDelegate(ByVal Name As String)

    Private Sub AccessGranted(ByVal Name As String)
        txtEmployeeName.Text = Name
        elpAccessGranted.Visibility = Windows.Visibility.Visible
        lblAccessGranted.Visibility = Windows.Visibility.Visible
        elpAccessDenied.Visibility = Windows.Visibility.Hidden
        lblAccessDenied.Visibility = Windows.Visibility.Hidden
    End Sub
    Private Delegate Sub AccessDeniedDelegate(ByVal Name As String)

    Private Sub AccessDenied(ByVal Name As String)
        txtEmployeeName.Text = Name
        elpAccessDenied.Visibility = Windows.Visibility.Visible
        lblAccessDenied.Visibility = Windows.Visibility.Visible
        elpAccessGranted.Visibility = Windows.Visibility.Hidden
        lblAccessGranted.Visibility = Windows.Visibility.Hidden
    End Sub
    Private Sub InvalidCard()
        txtEmployeeName.Text = "Invalid Card"
        elpAccessDenied.Visibility = Windows.Visibility.Visible
        lblAccessDenied.Visibility = Windows.Visibility.Visible
        elpAccessGranted.Visibility = Windows.Visibility.Hidden
        lblAccessGranted.Visibility = Windows.Visibility.Hidden
    End Sub


End Class
