﻿//SecurityMSR_CS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2011 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Data.OleDb;
using Microsoft.PointOfService;
using System.Windows.Threading;


namespace SecurityMSR_CS
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 
    

    public partial class MainWindow : Window
    {

        private PosExplorer myExplorer;
        public Msr myMsr;

        public MainWindow()
        {
            InitializeComponent();
            myExplorer = new PosExplorer();
            myExplorer.DeviceAddedEvent +=new DeviceChangedEventHandler(myExplorer_DeviceAddedEvent);
            myExplorer.DeviceRemovedEvent +=new DeviceChangedEventHandler(myExplorer_DeviceRemovedEvent);
            DeviceInfo device = myExplorer.GetDevice("Msr", "myMSR");

            try
            {
                myMsr = (Msr)myExplorer.CreateInstance(device);
                myMsr.Open();
                myMsr.Claim(1000);
                myMsr.DataEvent += new DataEventHandler(myMsr_DataEvent);
                myMsr.DeviceEnabled = true;
                myMsr.DataEventEnabled = true;
                myMsr.DecodeData = true;
                txtEmployeeName.Text = "Ready";
            }
            catch
            {
                txtEmployeeName.Text = "Msr Not Found";
            }
            elpAccessDenied.Visibility = System.Windows.Visibility.Hidden;
            lblAccessDenied.Visibility = System.Windows.Visibility.Hidden;
            elpAccessGranted.Visibility = System.Windows.Visibility.Hidden;
            lblAccessGranted.Visibility = System.Windows.Visibility.Hidden;

        }

        void myExplorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Msr")
            {
                myMsr = (Msr)myExplorer.CreateInstance(e.Device);
                myMsr.Open();
                myMsr.Claim(1000);
                myMsr.DataEvent += new DataEventHandler(myMsr_DataEvent);
                myMsr.DeviceEnabled = true;
                myMsr.DataEventEnabled = true;
                myMsr.DecodeData = true;
                Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(MSRAttached));
            }
        }

        void myExplorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Msr")
            {
                myMsr.DataEventEnabled = false;
                myMsr.DeviceEnabled = false;
                myMsr.Release();
                myMsr.Close();
                Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(MSRDetached));
            }
        }

        private void MSRDetached()
        {
            txtEmployeeName.Text = "Msr Detached";
            elpAccessDenied.Visibility = System.Windows.Visibility.Hidden;
            lblAccessDenied.Visibility = System.Windows.Visibility.Hidden;
            elpAccessGranted.Visibility = System.Windows.Visibility.Hidden;
            lblAccessGranted.Visibility = System.Windows.Visibility.Hidden;
        }

        private void MSRAttached()
        {
            txtEmployeeName.Text = "New Msr attached";
        }

        void myMsr_DataEvent(object sender, DataEventArgs e)
        {
            ASCIIEncoding myEncoding = new ASCIIEncoding();
            String msrData;
            bool InvCard = true;

            msrData = myEncoding.GetString(myMsr.Track2Data);

            OleDbConnection dbConnect;
            OleDbCommand dbCommand;
            OleDbDataReader dbReader;

            dbConnect = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\\Database\\POS_ID.mdb");
            dbConnect.Open();
            dbCommand = new OleDbCommand("SELECT EmployeeID, Name, BadgeNumber, Access FROM Employees", dbConnect);
            dbReader = dbCommand.ExecuteReader();

            while(dbReader.Read())
            {
                String strID = dbReader.GetInt32(0).ToString();
                String Name = dbReader.GetString(1);
                String Badge = dbReader.GetString(2);
                Boolean Access = dbReader.GetBoolean(3);

                if (Badge == msrData)
                {
                    if (Access)
                    {

                        Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(
                            delegate()
                            {
                                txtEmployeeName.Text = Name;
                                elpAccessGranted.Visibility = System.Windows.Visibility.Visible;
                                lblAccessGranted.Visibility = System.Windows.Visibility.Visible;
                                elpAccessDenied.Visibility = System.Windows.Visibility.Hidden;
                                lblAccessDenied.Visibility = System.Windows.Visibility.Hidden;
                            }

                            ));
                        InvCard = false;
                        break;
                    }
                    else
                    {
                        Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(
                            delegate()
                            {
                                txtEmployeeName.Text = Name;
                                elpAccessDenied.Visibility = System.Windows.Visibility.Visible;
                                lblAccessDenied.Visibility = System.Windows.Visibility.Visible;
                                elpAccessGranted.Visibility = System.Windows.Visibility.Hidden;
                                lblAccessGranted.Visibility = System.Windows.Visibility.Hidden;
                            }
                            ));
                        InvCard = false;
                        break;
                    }
                }
            }
            
            if(InvCard == true)
            {
                Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(InvalidCard));

            }
            
            dbReader.Close();
            dbReader = null;
            dbConnect.Close();
            dbConnect = null;
            myMsr.DataEventEnabled = true;
        }


        private void InvalidCard()
        {
            txtEmployeeName.Text = "Invalid Card";
            elpAccessDenied.Visibility = System.Windows.Visibility.Visible;
            lblAccessDenied.Visibility = System.Windows.Visibility.Visible;
            elpAccessGranted.Visibility = System.Windows.Visibility.Hidden;
            lblAccessGranted.Visibility = System.Windows.Visibility.Hidden;
        }
        
    }
}
